package io.gitlab.jfronny.libjf.devutil;

import com.mojang.authlib.minecraft.TelemetryEvent;
import com.mojang.authlib.minecraft.TelemetryPropertyContainer;
import com.mojang.authlib.minecraft.TelemetrySession;
import com.mojang.authlib.minecraft.UserApiService;
import com.mojang.authlib.minecraft.report.AbuseReportLimits;
import com.mojang.authlib.yggdrasil.request.AbuseReportRequest;
import com.mojang.authlib.yggdrasil.response.*;
import org.jetbrains.annotations.*;

import java.util.*;
import java.util.concurrent.Executor;
import java.util.function.Consumer;

public class NoOpUserApi implements UserApiService {
    @Override
    public UserProperties properties() {
        return new UserProperties(Set.of(UserFlag.CHAT_ALLOWED, UserFlag.SERVERS_ALLOWED), Map.of());
    }

    @Override
    public boolean isBlockedPlayer(UUID playerID) {
        return false;
    }

    @Override
    public void refreshBlockList() {
    }

    @Override
    public TelemetrySession newTelemetrySession(Executor executor) {
        return new TelemetrySession() {
            @Override
            public boolean isEnabled() {
                return false;
            }

            @Override
            public TelemetryEvent createNewEvent(String type) {
                return new TelemetryEvent() {
                    @Override
                    public void send() {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, String value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, int value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, boolean value) {
                        // ignored
                    }

                    @Override
                    public void addNullProperty(String id) {
                        // ignored
                    }
                };
            }
        };
    }

    @Nullable
    @Override
    public KeyPairResponse getKeyPair() {
        return null;
    }

    @Override
    public void reportAbuse(AbuseReportRequest request) {
    }

    @Override
    public boolean canSendReports() {
        return false;
    }

    @Override
    public AbuseReportLimits getAbuseReportLimits() {
        return new AbuseReportLimits(0, 0, 0, 0, 0);
    }
}
